ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.31 by root, Thu Apr 26 00:39:18 2007 UTC vs.
Revision 1.52 by root, Sat Aug 18 22:25:35 2007 UTC

6my $exec_prefix = "@exec_prefix@"; 6my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 7my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 8my $DATADIR = "@datadir@/@PACKAGE@";
9 9
10my $CONVERT = "@CONVERT@"; 10my $CONVERT = "@CONVERT@";
11my $IDENTIFY = "@IDENTIFY@"; 11#my $IDENTIFY = "@IDENTIFY@";
12my $OPTIPNG = "@OPTIPNG@"; 12my $OPTIPNG = "@OPTIPNG@";
13my $RSYNC = "@RSYNC@"; 13my $RSYNC = "@RSYNC@";
14my $PNGNQ = "@PNGNQ@"; 14my $PNGNQ = "@PNGNQ@";
15 15
16use Getopt::Long; 16use Getopt::Long;
19use IO::AIO (); 19use IO::AIO ();
20use File::Temp; 20use File::Temp;
21use Crossfire; 21use Crossfire;
22use Coro; 22use Coro;
23use Coro::AIO; 23use Coro::AIO;
24use Coro::Util;
24use POSIX (); 25use POSIX ();
25use Digest::MD5; 26use Digest::MD5;
27use Carp;
26use Coro::Storable; $Storable::canonical = 1; 28use Coro::Storable; $Storable::canonical = 1;
29
30$SIG{QUIT} = sub { Carp::cluck "QUIT" };
27 31
28sub usage { 32sub usage {
29 warn <<EOF; 33 warn <<EOF;
30Usage: cfutil [-v] [-q] [--force] [--cache] 34Usage: cfutil [-v] [-q] [--force] [--cache]
31 [--install-arch path] 35 [--install-arch path]
43my $CACHE = 0; 47my $CACHE = 0;
44my $FORCE; 48my $FORCE;
45my $TMPDIR = "/tmp/cfutil$$~"; 49my $TMPDIR = "/tmp/cfutil$$~";
46my $TMPFILE = "aaaa0"; 50my $TMPFILE = "aaaa0";
47 51
52our %COLOR = (
53 black => 0,
54 white => 1,
55 navy => 2,
56 red => 3,
57 orange => 4,
58 blue => 5,
59 darkorange => 6,
60 green => 7,
61 lightgreen => 8,
62 grey => 9,
63 brown => 10,
64 gold => 11,
65 tan => 12,
66);
67
48END { system "rm", "-rf", $TMPDIR } 68END { system "rm", "-rf", $TMPDIR }
49 69
50Event->signal (signal => "INT", cb => sub { exit 1 }); 70Event->signal (signal => "INT", cb => sub { exit 1 });
51Event->signal (signal => "TERM", cb => sub { exit 1 }); 71Event->signal (signal => "TERM", cb => sub { exit 1 });
52 72
76 if (!-f "$path/regions") { 96 if (!-f "$path/regions") {
77 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 97 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
78 exit 1 unless $FORCE; 98 exit 1 unless $FORCE;
79 } 99 }
80 100
81 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded" 101 system $RSYNC, "-a", "--chmod=u=rwX,go=rX", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"
82 and die "map installation failed.\n"; 102 and die "map installation failed.\n";
83 103
84 print "maps installed successfully.\n"; 104 print "maps installed successfully.\n";
85} 105}
86 106
87{ 107{
88 our %ANIMINFO; 108 our %ANIMINFO;
89 our %FACEINFO; 109 our %FACEINFO;
110 our %RESOURCE;
90 our @ARC; 111 our @ARC;
91 our %ARC; 112 our %ARC;
92 our $TRS; 113 our $TRS;
93 our $NFILE; 114 our $NFILE;
115 our $PATH;
94 116
95 our $QUANTIZE = "+dither -colorspace RGB -colors 256"; 117 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
96 118
97 our (@png, @trs, @arc); # files we are interested in 119 our (@png, @trs, @arc, @res); # files we are interested in
98 120
99 sub commit_png($$$) { 121 sub commit_png($$$) {
100 my ($name, $data, $T) = @_; 122 my ($name, $data, $T) = @_;
101 123
102 $FACEINFO{$name}{"data$T"} = $data; 124 $FACEINFO{$name}{"data$T"} = $data;
149 # possibly enlarge 171 # possibly enlarge
150 if (0 > aio_stat "$stem.64x64.png") { 172 if (0 > aio_stat "$stem.64x64.png") {
151 my $other = "$stem.64x64.png~"; 173 my $other = "$stem.64x64.png~";
152 174
153 if (0 > aio_lstat $other or (-M _) > (-M $path)) { 175 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
154 my $wrap = 0; # for the time being
155 fork_sub { 176 fork_sub {
177 my $CROP;
178 my $SRC = "png:\Q$path\E";
179
180 # check if this is a wall. ultra-ugly. ultra-ultra-ugly.
181 if ($path =~ /^(.*\/wall\/.*_)([0-9A-F])(\.x11.*\.png)$/) {
182 my ($pfx, $dir, $sfx) = ($1, hex $2, $3);
183 #check for 0..F images to be sure(?) this is a wall
184 unless (grep { !-e sprintf "%s%X%s", $pfx, $_, $sfx } 0..15) {
185 # add a 4px border and add other images around it
186 $CROP = "-shave 8x8 +repage";
187
188 $w += 8;
189 $h += 8;
190
191 $SRC = "-size ${w}x${h} xc:transparent";
192 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
193
194 # 8 surrounding images
195 for (
196 # x y b r0 r1
197 [-1, -1, 0, 6],
198 [ 0, -1, 1, 10, 14],
199 [+1, -1, 0, 12],
200
201 [-1, 0, 8, 5, 7],
202 #
203 [+1, 0, 2, 5, 13],
204
205 [-1, +1, 0, 3],
206 [ 0, +1, 4, 10, 11],
207 [+1, +1, 0, 9],
208 ) {
209 my ($x, $y, $d, $r0, $r1) = @$_;
210 $SRC .= sprintf " png:%s%X%s -geometry %+d%+d -composite",
211 "\Q$pfx",
212 ($dir & $d) ? $r1 : $r0,
213 "\Q$sfx",
214 $x * ($w - 8) + 4,
215 $y * ($h - 8) + 4;
216 }
217 }
218 }
219
156 system "convert png:\Q$path\E -depth 8 rgba:-" 220 system "convert -depth 8 $SRC rgba:-"
157 . "| $exec_prefix/bin/cfhq2xa $w $h $wrap" 221 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
158 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $QUANTIZE -quality 00 png32:\Q$other\E~" 222 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
159 and die "convert/hq2xa pipeline error: status $? ($!)"; 223 and die "convert/cfhq2xa pipeline error: status $? ($!)";
160 system $OPTIPNG, "-i0", "-q", "$other~"; 224 system $OPTIPNG, "-i0", "-q", "$other~";
161 die "$other~ has zero size, aborting." unless -s "$other~"; 225 die "$other~ has zero size, aborting." unless -s "$other~";
162 rename "$other~", $other; 226 rename "$other~", $other;
163 }; 227 };
164 } 228 }
177 241
178 # reduce smoothfaces >10000 bytes 242 # reduce smoothfaces >10000 bytes
179 if ($stem =~ /_S\./ && (-s "$other~") > 10000) { 243 if ($stem =~ /_S\./ && (-s "$other~") > 10000) {
180 my $ncolor = 256; 244 my $ncolor = 256;
181 while () { 245 while () {
182 system "<\Q$other~\E $PNGNQ -n$ncolor >\Q$other~~\E"; 246 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
183 system $OPTIPNG, "-i0", "-q", "$other~~"; 247 system $OPTIPNG, "-i0", "-q", "$other~~";
184 last if 10000 > -s "$other~~"; 248 last if 10000 > -s "$other~~";
185 $ncolor = int $ncolor * 0.9; 249 $ncolor = int $ncolor * 0.9;
186 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes"; 250 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
187 } 251 }
188 252
189 printf "reduced %s from %d to %d bytes using %d colours.\n", 253 printf "reduced %s from %d to %d bytes using %d colours.\n",
190 $other, -s "$other~", -s "$other~~", $ncolor 254 $other, -s "$other~", -s "$other~~", $ncolor
191 if $VERBOSE > 0; 255 if $VERBOSE >= 2;
192 rename "$other~~", "$other~"; 256 rename "$other~~", "$other~";
193 } 257 }
194 258
195 die "$other~ has zero size, aborting." unless -s "$other~"; 259 die "$other~ has zero size, aborting." unless -s "$other~";
196 rename "$other~", $other; 260 rename "$other~", $other;
301 365
302 my $ext = $x|$y ? "+$x+$y" : ""; 366 my $ext = $x|$y ? "+$x+$y" : "";
303 367
304 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face}; 368 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
305 369
306 my $visibility = delete $o->{visibility} if exists $o->{visibility}; 370 $visibility = delete $o->{visibility} if exists $o->{visibility};
307 my $magicmap = delete $o->{magicmap} if exists $o->{magicmap}; 371 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
308 372
309 my $anim = delete $o->{anim}; 373 my $anim = delete $o->{anim};
310 374
311 if ($anim) { 375 if ($anim) {
312 # possibly add $ext to the animation name to avoid 376 # possibly add $ext to the animation name to avoid
367 431
368 $TRS .= $trs; 432 $TRS .= $trs;
369 } 433 }
370 } 434 }
371 435
436 my %FILECACHE;
437
438 sub load_cached($;$) {
439 unless (exists $FILECACHE{$_[0]}) {
440 my $data;
441 if (0 < aio_load $_[0], $data) {
442 if ($_[1]) {
443 $data = eval { $_[1]->($data) };
444 warn "$_[0]: $@" if $@;
445 }
446 }
447
448 $FILECACHE{$_[0]} = $data;
449 }
450
451 $FILECACHE{$_[0]}
452 }
453
454 sub process_res {
455 while (@res) {
456 my ($dir, $file, $type) = @{pop @res};
457
458 my $data;
459 aio_load "$dir/$file", $data;
460
461 my $meta = load_cached "$dir/meta", sub { JSON::XS::from_json shift };
462
463 next if $meta && !exists $meta->{$file};
464
465 $meta = {
466 %{ $meta->{"" } || {} },
467 %{ $meta->{$file} || {} },
468 };
469
470 if ($meta->{license} =~ s/^#//) {
471 $meta->{license} = ({
472 "pd" => "Public Domain",
473 "gpl" => "GNU General Public License, version 3.0 or any later",
474 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
475 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.5/",
476 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
477 })->{$meta->{license}}
478 || warn "$dir/$file: license tag '$meta->{license}' not found.";
479 }
480
481 $file =~ s/\.res$//;
482 $file =~ s/\.(ogg|wav|jpg|png)$//;
483
484 substr $dir, 0, 1 + length $PATH, "";
485
486 $RESOURCE{"$dir/$file"} = {
487 type => (delete $meta->{type}) || $type,
488 data => $data,
489 chksum => (Digest::MD5::md5 $data),
490 %$meta ? (meta => $meta) : (),
491 };
492 }
493 }
494
372 sub find_files; 495 sub find_files;
373 sub find_files { 496 sub find_files {
374 my ($path) = @_; 497 my ($path) = @_;
375 498
376 IO::AIO::aioreq_pri 4; 499 IO::AIO::aioreq_pri 4;
378 my ($dirs, $nondirs) = @_; 501 my ($dirs, $nondirs) = @_;
379 502
380 find_files "$path/$_" 503 find_files "$path/$_"
381 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 504 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs;
382 505
506 my $dir = $path;
507 substr $dir, 0, 1 + length $PATH, "";
508
383 for my $file (@$nondirs) { 509 for my $file (@$nondirs) {
510 if ($dir =~ /^music(?:\/|$)/) {
511 push @res, [$path, $file, 3] # FT_MUSIC
512 if $file =~ /\.(ogg)$/;
513
514 } elsif ($dir =~ /^sound(?:\/|$)/) {
515 push @res, [$path, $file, 5] # FT_SOUND
516 if $file =~ /\.(wav|ogg)$/;
517
518 } elsif ($dir =~ /^res(?:\/|$)/) {
519 push @res, [$path, $file, 0] # FT_FACE
520 if $file =~ /\.(jpg|png)$/;
521 push @res, [$path, $file, 7] # FT_RSRC
522 if $file =~ /\.(res)$/;
523
384 if ($file =~ /\.png$/) { 524 } elsif ($file =~ /\.png$/) {
385 push @png, ["$path/$file", 0]; 525 push @png, ["$path/$file", 0];
526
386 } elsif ($file =~ /\.trs$/) { 527 } elsif ($file =~ /\.trs$/) {
387 push @trs, [$path, $file]; 528 push @trs, [$path, $file];
529
388 } elsif ($file =~ /\.arc$/) { 530 } elsif ($file =~ /\.arc$/) {
389 push @arc, [$path, $file]; 531 push @arc, [$path, $file];
532
390 } else { 533 } else {
391 warn "ignoring $path/$file\n" if $VERBOSE >= 2; 534 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
392 } 535 }
393 } 536 }
394 }; 537 };
395 } 538 }
396 539
397 sub inst_arch($) { 540 sub inst_arch($) {
398 my (undef, $path) = @_; 541 my (undef, $path) = @_;
542
543 $PATH = $path;
399 544
400 print "\n", 545 print "\n",
401 "Installing '$path' to '$DATADIR'\n", 546 "Installing '$path' to '$DATADIR'\n",
402 "\n", 547 "\n",
403 "This can take a long time if you run this\n", 548 "This can take a long time if you run this\n",
418 $_->join for ( 563 $_->join for (
419 # four png crunchers work fine for my 2x smp machine 564 # four png crunchers work fine for my 2x smp machine
420 (async \&process_png), (async \&process_png), (async \&process_png), (async \&process_png), 565 (async \&process_png), (async \&process_png), (async \&process_png), (async \&process_png),
421 (async \&process_trs), (async \&process_trs), 566 (async \&process_trs), (async \&process_trs),
422 (async \&process_arc), (async \&process_arc), 567 (async \&process_arc), (async \&process_arc),
568 (async \&process_res), (async \&process_res),
423 ); 569 );
424 570
425 { 571 {
426 # remove path prefix from editor_folder 572 # remove path prefix from editor_folder
427 substr $_->{editor_folder}, 0, 1 + length $path, "" 573 substr $_->{editor_folder}, 0, 1 + length $path, ""
457 603
458 last; 604 last;
459 } 605 }
460 } 606 }
461 607
608 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
609 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
610
462 open my $fh, ">:utf8", "$DATADIR/archetypes~" 611 open my $fh, ">:utf8", "$DATADIR/archetypes~"
463 or die "$DATADIR/archetypes~: $!"; 612 or die "$DATADIR/archetypes~: $!";
464 print $fh Crossfire::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC]; 613 print $fh Crossfire::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
465 } 614 }
466 615
478 length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n"; 627 length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
479 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n"; 628 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
480 629
481 $v->{chksum32} = Digest::MD5::md5 $v->{data32}; 630 $v->{chksum32} = Digest::MD5::md5 $v->{data32};
482 $v->{chksum64} = Digest::MD5::md5 $v->{data64}; 631 $v->{chksum64} = Digest::MD5::md5 $v->{data64};
632
633 if (my $magicmap = $v->{magicmap}) {
634 $magicmap =~ y/A-Z_\-/a-z/d;
635 $v->{magicmap} = $COLOR{$magicmap};
636 }
483 } 637 }
484 638
485 open my $fh, ">:perlio", "$DATADIR/facedata~" 639 open my $fh, ">:perlio", "$DATADIR/facedata~"
486 or die "$DATADIR/facedata~: $!"; 640 or die "$DATADIR/facedata~: $!";
487 641
488 print $fh freeze { 642 print $fh freeze {
489 version => 2, 643 version => 2,
490 faceinfo => \%FACEINFO, 644 faceinfo => \%FACEINFO,
491 animinfo => \%ANIMINFO, 645 animinfo => \%ANIMINFO,
646 resource => \%RESOURCE,
492 }; 647 };
493 } 648 }
494 649
495 for (qw(archetypes facedata treasures)) { 650 for (qw(archetypes facedata treasures)) {
496 chmod 0644, "$DATADIR/$_~"; 651 chmod 0644, "$DATADIR/$_~";

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines